package com.yusukeshibata.universal.canvas;

import android.util.Log;
import com.facebook.react.bridge.ReadableArray;
import com.facebook.react.bridge.ReactContext;
import com.facebook.react.uimanager.annotations.ReactProp;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.uimanager.PixelUtil;
import com.facebook.react.uimanager.SimpleViewManager;
import com.facebook.react.uimanager.ThemedReactContext;

public class UniversalCanvasManager extends SimpleViewManager<UniversalCanvasView> {

	private static final String TAG = "ReactNative";
	public static final String REACT_CLASS = "UniversalCanvas";
	private ReactContext reactContext;

	@Override
	public String getName() {
		return REACT_CLASS;
	}

	@Override
	protected UniversalCanvasView createViewInstance(ThemedReactContext context) {
		reactContext = context;
		return new UniversalCanvasView(context);
	}

	@ReactProp(name="context")
	public void setContext(UniversalCanvasView view,int contextId) {
		UniversalCanvasModule module = reactContext.getNativeModule(UniversalCanvasModule.class);
		module.setView(contextId,view);
	}

}
