package com.yusukeshibata.universal.canvas;

import java.util.*;
import android.util.Log;
import android.app.Activity;
import android.support.annotation.Nullable;
import com.facebook.react.ReactActivity;
import com.facebook.react.bridge.*;

public class UniversalCanvasModule extends ReactContextBaseJavaModule {

	private static final String TAG = "ReactNative";
	private Map<Integer,UniversalCanvasView> map = new HashMap<Integer,UniversalCanvasView>();
	private int id = 0;
	private ReactApplicationContext reactContext;

	public UniversalCanvasModule(ReactApplicationContext reactContext) {
		super(reactContext);
		this.reactContext = reactContext;
	}

	@Override
	public String getName() {
		return getClass().getSimpleName();
	}

	public UniversalCanvasView getView(int contextId) {
		return this.map.get(contextId);
	}

	public void setView(int contextId,UniversalCanvasView view) {
		this.map.put(contextId,view);
	}

	@ReactMethod
	public void createContext(Callback callback) {
		int newId = this.id++;
		callback.invoke(newId);
	}

	@ReactMethod
	public void freeContext(int contextId) {
		this.map.remove(contextId);
	}
}

