module.exports = {
  entry: {
    index: './src/index'
  },
  watch: false,
  context: __dirname,
  output: {
    filename: './lib/[name].js',
    pathinfo: false,
    library: 'index',
    libraryTarget: 'umd'
  },
  module: {
    preLoaders: [
      {
        test: /\.(js|jsx)$/,
        include: 'src',
        loader: 'eslint-loader'
      }
    ],
    loaders: [
      {
        test: /\.(js|jsx)$/,
        loader: 'babel-loader'
      }
    ]
  },
  resolve: {
    modulesDirectories: ['node_modules']
  },
  externals: [
    {
      'react': {
        root: 'React',
        commonjs2: 'react',
        commonjs: 'react',
        amd: 'react'
      }
    },
    {
      'react-dom': {
        root: 'ReactDOM',
        commonjs2: 'react-dom',
        commonjs: 'react-dom',
        amd: 'react-dom'
      }
    }
  ]
}
